// Last Updated: 15-04-20
// Useless Box Project, using 3 servos and 2 Neopixel LEDs

#include <Adafruit_NeoPixel.h>
#define PIN1           2
// How many NeoPixels are attached to the Arduino?
#define NUMPIXELS      1
Adafruit_NeoPixel pixels1 = Adafruit_NeoPixel(NUMPIXELS, PIN1, NEO_GRB + NEO_KHZ800);

#include <Servo.h> 
Servo doorServo;
Servo fingerServo;
Servo eyesServo;

int pos = 0;
int selectedMove = 0;             //move selector
const int buttonPin = 12;     // the number of the pushbutton pin
const int ledPin =  13;      // the number of the LED pin
int buttonState = 0;         // variable for reading the pushbutton status
int randNumber;

void setup()
{
  Serial.begin(9600);
  randomSeed(analogRead(0));
  // Set pins 9,10, and 11 to output

  pinMode(9, OUTPUT); // Door
  pinMode(10,OUTPUT); // finger
  pinMode(11, OUTPUT); // eyes
  // initialize the LED pin as an output:
  pinMode(ledPin, OUTPUT);
  // initialize the pushbutton pin as an input:
  pinMode(buttonPin, INPUT);
  doorServo.attach(9);           //set door servo on Pin 9 pwm
  doorServo.write(10);           //set door to hiding position 
  fingerServo.attach(10);        //set finger servo on Pin 10 pwm
  fingerServo.write(150);        //set finger to hiding position
  eyesServo.attach(11);           //set eyes servo on Pin 11 pwm
  eyesServo.write(120);          //set eyes to hiding position

  pixels1.begin(); // This initializes the NeoPixel library.
  pixels1.show();

}

void loop(){
  // read the state of the pushbutton value:
  buttonState = 0;
  buttonState = digitalRead(buttonPin);

  // check if the pushbutton is pressed. If it is, the buttonState is HIGH:
  if (buttonState == HIGH) 
  {
    // turn LED on:
    digitalWrite(ledPin, HIGH);
    if (selectedMove > 9) 
    { 
        selectedMove = 0; 
    } //when all moves are played, repeat the moves from beginning 
    
        if (selectedMove == 0) 
        { 
          simpleClose(); 
        }
        else if (selectedMove == 1) 
            { 
              simpleClose(); 
            }   
            else if (selectedMove == 2) 
                  { 
                    simpleClose2(); 
                  }
                  else if (selectedMove == 3) 
                        { 
                          crazydoor(); 
                        }
                        else if (selectedMove == 4) 
                              { 
                                slow(); 
                              }
                              else if (selectedMove == 5) 
                                    { 
                                      serious(); 
                                    }
                                    else if (selectedMove == 6) 
                                          { 
                                            trollClose(); 
                                          }
                                          else if (selectedMove == 7) 
                                                { 
                                                  simpleClose2; 
                                                }
                                                else if (selectedMove == 8) 
                                                      { 
                                                        matrix(); 
                                                      }
                                                    else if (selectedMove == 9) 
                                                          { 
                                                            sneak(); 
                                                          }    
          selectedMove += 1;         //swith to next move    
    } else 
      {
        // turn LED off:
        digitalWrite(ledPin, LOW);
      }
}

// 0 - 1 - Open Door, extend finger, switch off, withdraw finger, close door
// Moves - Door 0 - 70 - Open, Finger 150 - 10 - Move Out
//       - Door 70 - 0 - Close, Finger 10 - 150 - Move In
void simpleClose() 
{    
  Serial.print("simpleclose ");
  Serial.println(selectedMove);
    //Opening door
    for(pos = 0; pos <=70; pos +=3)   
    {                                   
      doorServo.write(pos);              
      delay(15);                       
    }
    open_eyes();          
    //extend finger
    for(pos = 150; pos >= 10; pos -=4)     
    {                                
      fingerServo.write(pos);               
      delay(15); 
    } 
    //withdraw finger    
    for(pos = 10; pos <= 150; pos +=4)  
    {                                   
      fingerServo.write(pos);               
      delay(15);                       
    }   
    close_eyes();    
    //Closing door
    for(pos = 70; pos >= 0; pos -=3)     
    {                                
      doorServo.write(pos);              
      delay(15);                      
    } 
} 
     
// 2 - open door and wait, then extend finger and wait, then switch of, withdraw finger, close door  
// Moves - Door 0 - 70 - Open, Finger 150 - 10 - Move Out
//       - Door 70 - 0 - Close, Finger 10 - 150 - Move In
void simpleClose2()
{
  Serial.print("simpleclose2 ");
  Serial.println(selectedMove);
    //open door
    for(pos = 0; pos < 70; pos +=3)   
    {                                   
      doorServo.write(pos);              
      delay(15);                       
    }
    delay(700); 
    open_eyes();
    //extend hand
    for(pos = 150; pos >= 110; pos -=4)  
    {                                   
      fingerServo.write(pos);               
      delay(15);                       
    }
    delay(3000); 
    for(pos = 110; pos >= 10; pos -=4)  
    {                                   
      fingerServo.write(pos);              
      delay(15);                       
    }        
    //withdraw hand
    for(pos = 10; pos <= 150; pos +=4)      
    {                                
      fingerServo.write(pos);               
      delay(15);                        
    }      
    delay(700); 
    close_eyes();
    //closing door
    for(pos = 70; pos>= 0; pos -= 3)     
    {                                
      doorServo.write(pos);              
      delay(15);                       
   }      
}
  
// 3 - open door then close it many times, wait, then quickly reopen, switch off and hide.
// Moves - Door 0 - 70 - Open, Finger 150 - 10 - Move Out
//       - Door 70 - 0 - Close, Finger 10 - 150 - Move In  
   void crazydoor()
  {
  Serial.print("crazydoor ");
  Serial.println(selectedMove);    
   //Open and close door 3 times
   for (int i = 1; i <=3; ++i)
   {
      for(pos = 0; pos <= 70; pos += 3)   
      {                                   
          doorServo.write(pos);              
          delay(15);                       
      }
      //hiding door
      for(pos = 70; pos >=0; pos -= 3)     
      {                                
        doorServo.write(pos);              
        delay(15);                      
      }
   }      
   //Open door
    for(pos = 0; pos <= 70; pos += 3)   
    {                                   
      doorServo.write(pos);              
      delay(15);                       
    } 
    open_eyes(); 
    //extend hand
    for(pos = 150; pos >= 10; pos -= 4)  
    {                                   
      fingerServo.write(pos);               
      delay(15);                       
    }      
    //withdraw hand
    for(pos = 10; pos <=150; pos +=4)      
    {                                
      fingerServo.write(pos);               
      delay(15);                        
    }       
    close_eyes();
    //close door
    for(pos = 70; pos >=0; pos -=3)     
    {                                
    doorServo.write(pos);              
    delay(15);                      
    }    
  }   

// 4 - open door, extend finger very slowly forward and withdraw to hiding very slowly, then quickly close door
// Moves - Door 0 - 70 - Open, Finger 150 - 10 - Move Out
//       - Door 70 - 0 - Close, Finger 10 - 150 - Move In  
 void slow()
 {
  Serial.print("slow ");
  Serial.println(selectedMove);
    //Open door
    for(pos = 0; pos <= 70; pos += 3)   
    {                                   
      doorServo.write(pos);              
      delay(30);                       
    }  
    open_eyes(); 
    //extend hand
    for(pos = 150; pos >= 10; pos -= 1)  
    {                                   
      fingerServo.write(pos);               
      delay(30);                       
    }  
    //withdraw hand
    for(pos = 10; pos <=150; pos += 1)      
    {                                
      fingerServo.write(pos);               
      delay(30);                        
    }       
    close_eyes();
    //closing door
    for(pos = 70; pos >=40; pos -= 1)     
    {                                
      doorServo.write(pos);              
      delay(30);                      
    }
    delay(1000);
    for(pos = 40; pos >=0; pos -= 4)     
    {                                
        doorServo.write(pos);              
        delay(15);                      
    }    
 }
 
// 5 - serious - open door fully, extend finger half way, withdraw finger, close door to 1/3, open door 2/3, close
// door to 1/3, repeat 3 times, open door fully, slow extend of finger, quick withdraw
// Moves - Door 0 - 70 - Open, Finger 150 - 10 - Move Out
//       - Door 70 - 0 - Close, Finger 10 - 150 - Move In   
void serious() 
{
  Serial.print("serious ");
  Serial.println(selectedMove);
 
    //Open door fully
    for(pos = 0; pos <= 70; pos += 3)   
    {                                   
      doorServo.write(pos);              
      delay(15);                       
    } 
    open_eyes();    
    //extend finger 1/2 way
    for(pos = 150; pos >= 70; pos -= 1)  
    {                                   
      fingerServo.write(pos);               
      delay(15);                       
    }
    delay(700);    
    //withdraw finger
    for(pos = 70; pos <= 150; pos += 1)  
    {                                   
      fingerServo.write(pos);               
      delay(15);                       
    }
    delay(700); 
    close_eyes();       
    //close door to 1/3
    for(pos = 70; pos >=30; pos -= 3)     
    {                                
    doorServo.write(pos);              
    delay(15); 
    }
    // open door 1/3, close to 1/3
    for (int i = 1; i <=3; i++)
    { 
      if (i == 1 or i == 3 )
      {    
        for(pos = 30; pos <=60; pos += 3) // open to 2/3
        {                           
          doorServo.write(pos);              
          delay(15);
        }  
      } else 
      {
        for(pos = 60; pos >=30; pos -= 3) // close to 1/3
        {                           
          doorServo.write(pos);              
          delay(15);
        }           
      }
    }
    //open door fully
    for(pos = 30; pos <=70; pos += 3)     
    {                                
        doorServo.write(pos);              
        delay(15); 
    }   
    delay(1000);
    open_eyes();
    //extend hand slowly
    for(pos = 150; pos >= 10; pos -= 1)  
    {                                   
      fingerServo.write(pos);               
      delay(15);                       
    }     
    //withdraw hand
    for(pos = 10; pos <=150; pos += 4)      
    {                                
      fingerServo.write(pos);               
      delay(15);                        
    }     
    close_eyes();
    // closing door  
    for(pos = 70; pos >=0; pos -= 1)   
    {                                   
        doorServo.write(pos);              
        delay(15);                       
    }    
} 
// 6 - trollclose - open door, extend finger, withdraw finger, close door to 2/3, open door fully, 
// close door to 2/3, close door from 1/3
// Moves - Door 0 - 70 - Open, Finger 150 - 10 - Move Out
//       - Door 70 - 0 - Close, Finger 10 - 150 - Move In  
void trollClose()
{
  Serial.print("trollclose ");
  Serial.println(selectedMove);
    //Open door
    for(pos = 0; pos <=70 ; pos += 3)   
    {                                   
      doorServo.write(pos);              
      delay(15);                       
    }  
    open_eyes();
    //extend finger
    for(pos = 150; pos >= 10; pos -= 4)  
    {                                   
      fingerServo.write(pos);               
      delay(15);                       
    }
    //withdraw finger
    for(pos = 10; pos <=150; pos += 4)      
    {                                
      fingerServo.write(pos);               
      delay(15);                        
    } 
    close_eyes();
    //close door from full to 2/3
    for(pos = 70; pos >=40; pos -= 1)     
    {                                
      doorServo.write(pos);              
      delay(15);                      
    }
    delay(1000);
    //open door from 2/3 to full
    for(pos = 40; pos <=70; pos += 3)     
    {                                
      doorServo.write(pos);              
      delay(15);                      
    }
    delay(1000);
    //close door from full to 2/3
    for(pos = 70; pos >=40; pos -= 1)     
    {                                
      doorServo.write(pos);              
      delay(15);                      
    }
    delay(1000);
    //close door from 2/3 to 1/3
    for(pos = 40; pos >=20; pos -= 1)     
    {                                
      doorServo.write(pos);              
      delay(15);                      
    }
    delay(1000);        
    //close door
    for(pos = 20; pos >=0; pos -= 3)     
    {                                
      doorServo.write(pos);              
      delay(15);                      
    }
}

// 8 - matrix, open door fully, extend finger quickly to 1/3 position then slowly to full position,
// withdraw finger, close door  
// Moves - Door 0 - 70 - Open, Finger 150 - 10 - Move Out
//       - Door 70 - 0 - Close, Finger 10 - 150 - Move In  
void matrix()
{
  Serial.print("matrix ");
  Serial.println(selectedMove);
    //open door fully
    for(pos = 0; pos <= 70; pos += 3)   
    {                                   
      doorServo.write(pos);              
      delay(15);                       
    }  
    //extend finger to 2/3 position quickly
    for(pos = 150; pos >= 90; pos -= 4)  
    {                                   
      fingerServo.write(pos);               
      delay(15);                       
    }
    open_eyes();
    // extend finger to full position slowly   
    for(pos = 90; pos >= 10; pos -= 1)  
    {                                   
      fingerServo.write(pos);               
      delay(30);                       
    }  
    delay(300);
    // withdraw finger
    for(pos = 10; pos <=150; pos +=4)      
    {                                
      fingerServo.write(pos);               
      delay(10);                        
    }       
    close_eyes();
    //closing door
    for(pos = 70; pos >=0; pos -=3)     
    {                                
      doorServo.write(pos);              
      delay(15);                      
    } 
  
}
// 9 - sneak - open door 2/3 slowly, extend finger slowly to 1/3 position, open door fully and slowly,
// extend finger slowly to full, 
// Moves - Door 0 - 70 - Open, Finger 150 - 10 - Move Out
//       - Door 70 - 0 - Close, Finger 10 - 150 - Move In  
void sneak() 
   {    
  Serial.print("sneak ");
  Serial.println(selectedMove);
   //open door to 2/3 slowly
    for(pos = 0; pos <= 60; pos += 1)   
    {                                   
      doorServo.write(pos);              
      delay(30);                       
    }
    delay(2000);  
    //extend finger to 1/3 position
    for(pos = 150; pos >= 100; pos -= 1)  
    {                                   
      fingerServo.write(pos);               
      delay(30);                       
    } 
    delay(2000);
    // open door fully, slowly
    for(pos = 60; pos <= 70; pos += 1)  
    {                                   
      doorServo.write(pos);               
      delay(15);                       
    }  
    open_eyes();
    delay(2000);
    //extend finger slowly to full
    for(pos = 100; pos >=10; pos -=1)      
    {                                
      fingerServo.write(pos);               
      delay(15);                        
    }
    // withdraw finger to 1/3 position slowly
    delay(2000);
    for(pos = 10; pos <= 100; pos += 1)  
    {                                   
      fingerServo.write(pos);               
      delay(15);                       
    }
    close_eyes();
    // close door to 2/3 slowly
    delay(2000);
    for(pos = 70; pos >=60; pos -=1)      
    {                                
      doorServo.write(pos);               
      delay(15);                        
    }
    delay(2000);
    // withdraw finger slowly      
    for(pos = 100; pos <= 150; pos += 1)  
    {                                   
      fingerServo.write(pos);               
      delay(15);                       
    } 
    //close door slowly
    for(pos = 60; pos >=0; pos -=1)     
    {                                
      doorServo.write(pos);              
      delay(15);                      
    } 
   }

void green_eyes()
{
      pixels1.setPixelColor(0,150,0,0); //Green    
      pixels1.show(); 
}

void eyes_off()
{
      pixels1.setPixelColor(0,0,0,0); //Off    
      pixels1.show(); 
}

void red_eyes()
{
      pixels1.setPixelColor(0,0,150,0); //Red    
      pixels1.show();  
}
void flashing_red_eyes()
{
  for(int j =1; j<=4; ++j)
  {
      pixels1.setPixelColor(0,0,150,0); //Red    
      pixels1.show(); 
      delay(50); 
      pixels1.setPixelColor(0,0,0,0); //Off    
      pixels1.show();
      delay(50); 
  }   
}
void blue_eyes()
{
      pixels1.setPixelColor(0,0,0,150); //Blue    
      pixels1.show();  
}
void open_eyes()
{
      // extend eyes and show Green eyes
    for(pos = 120; pos >= 20; pos -=4)     
    {                                
      eyesServo.write(pos);               
      delay(15); 
    }
    randomSeed(analogRead(0));
    randNumber = random(1,5);
    if (randNumber == 1 )
    {
        green_eyes();
    }    
    if (randNumber == 2 )
    {
        blue_eyes();
    }  
    if (randNumber == 3 )
    {
        red_eyes();
    } 
    if (randNumber == 4 or randNumber == 5)
    {
        flashing_red_eyes();
    } 
}    

void close_eyes()
{
    // switch off eyes and withdraw eyes
    for(pos = 20; pos <= 120; pos +=4)     
    {                                
      eyesServo.write(pos);               
      delay(15); 
    }
    eyes_off();
}
